// 投票
// 投票选项选择
$('.vote-item-wrap').on('click', 'li', function() {
    var _this = $(this),
        voteItem = _this.parent('.vote-item-wrap'),
        btn = _this.parent('.vote-item-wrap').siblings('.vote-btn');

    if(_this.hasClass('active')) {
        _this.removeClass('active');
    } else {
        // -1单选
        _this.parent().data('type') == '-1' ? _this.addClass('active').siblings('li').removeClass('active') : _this.addClass('active');
    }
    $(voteItem).find('.active').length == 0 ? $(btn).addClass('disable-vote-btn') : $(btn).removeClass('disable-vote-btn');
})

// 参与投票按钮
$('.vote-mod').on('click', '.vote-btn', function() {
    var _this = $(this),
        $vote = $('.vote'),
        uid = '', token = '', source = '', sign = '',
        optionlist = '';
    if(_this.hasClass('disable-vote-btn')) return;
    if(_this.hasClass('voted')) return;
    optionlist = getVoteRes(_this.siblings('.vote-item-wrap').children('li'));
    if(!optionlist) return;
    uid = $vote.attr('uid');
    token = $vote.attr('token');
    source = $vote.attr('source');
    sign = $vote.attr('sign');
    jm.hintNoNetworkMessage();
    $.ajax({
        url: 'https://a.jiemian.com/index.php?m=survey&a=index&id=' + _this.data('id') + '&optionlist=' + optionlist + '&uid=' + uid + '&token=' + token + '&source=' + source + '&sign=' + sign,
        type: 'get',
        async: false,
        dataType: 'jsonp',
        jsonp:"callback",
        success: function(data){
            if(!data.code) {
                getVoteCont();
            }
        },
        error:function(){
            jm.hintBadNetworkMessage();
        }
    })
});

function getVoteRes(obj) {
    var voteRes = '';
    obj.each(function(index, el) {
        if($(el).hasClass('active')) voteRes += $(el).data('id') + ',';
    })
    return voteRes.slice(0, voteRes.length-1)
}

// 获取投票内容
if($('.vote-wrap').length) {
    getVoteCont();
}
function getVoteCont() {
    var $vote = $('.vote'),
        voteId = '', uid = '', token = '', source = '', sign = '',
        tmp = '';

    $('.vote-wrap').each(function(i, el) {
        tmp += $(el).attr('mid') + ',';
    })

    voteId = tmp.slice(0, tmp.length-1);
    uid = $vote.attr('uid');
    token = $vote.attr('token');
    source = $vote.attr('source');
    sign = $vote.attr('sign');

    if(voteId) {
        $.ajax({
            url: 'https://a.jiemian.com/index.php?m=survey&a=getSurveySpecial&id=' + voteId + '&uid=' + uid + '&token=' + token + '&source=' + source + '&sign=' + sign,
            type: 'get',
            async: false,
            dataType: 'jsonp',
            jsonp:"callback",
            success: function(data){

                if(data.status == '0') {
                    handleVoteData(data.mess);
                }
            },
            error:function(){
            }
        })
    }
}

function handleVoteData(json) {
    // isvote 是否投过票，1是，0否
    // canvote 是否可以投票，1是，0否，（因为有投票过期时间等限制）
    // visible 是投票结果可见度，0任何人可见，1投票后可见
    // ispic 1是有图片投票，0是文字
    // opt_text 投票结果百分比，只有可显示结果的投票才有这个字段
    // showresult 1就是显示结果，0不显示结果

    $('.vote-wrap').each(function(i, el) {
        var voteTitle = $(el).find('.vote-title');

        if(json[$(el).attr('mid')].code == 1) {
            $(el).hide();
            return;
        }
        // 是否已经投过票
        if(json[$(el).attr('mid')].isvote == 1) {
            $(el).find('.vote-btn').addClass('voted').html('已参与');
            $(el).find('.vote-item-wrap').addClass('active');
        } else {
            // 是否可以投票
            if(json[$(el).attr('mid')].canvote == 0) {
                $(el).find('.vote-btn').addClass('voted').html('已结束');
                $(el).find('.vote-item-wrap').addClass('active');
            } else {
                $(el).find('.vote-btn').html('参与投票').addClass('disable-vote-btn');
            }
        }

        // 参与投票的人数
        $(el).find('.vote-people-num').html('已有' + json[$(el).attr('mid')].voters + '人参与');
        // 投票id
        $(el).find('.vote-btn').data('id', json[$(el).attr('mid')].id_encode);
        // maxcount -1 单选
        $(el).find('.vote-item-wrap').html(getList(json[$(el).attr('mid')].ispic, json[$(el).attr('mid')].ans, json[$(el).attr('mid')].showresut)).data('type', json[$(el).attr('mid')].question.maxcount);

        if(json[$(el).attr('mid')].question.maxcount >= 0) {
            voteTitle.text(voteTitle.text() + ' (多选)')
        } else {
            voteTitle.text(voteTitle.text() + ' (单选)')
        }

    })
}

// 获取投票数据
function getList(type, arr, result) {
    var voteDataStr = '';

    if(result) {//1 显示投票结果
        if(type == '1') {//1是图片选项投票
            for(var i = 0; i < arr.length; i++) {
                voteDataStr += '<li class="pic-item">' +
                                    '<i><img src="' + arr[i].image + '"></i>' +
                                    '<div class="percent-wrap">' +
                                        '<span class="vote-item-name">' + arr[i].item + '</span>' +
                                        '<div class="percent-inner"><span class="bar" style="width:' + arr[i].opt_text + '%"></span></div>' +
                                        '<span class="percent-val">' + arr[i].opt_text + '%</span>' +
                                    '</div>' +
                                '</li>';
            }
        } else {//0文字选项投票
            for(var i = 0; i < arr.length; i++) {
                voteDataStr += '<li>' +
                                    '<span class="vote-item-name">' + arr[i].item + '</span>' +
                                    '<div class="percent-wrap">' +
                                        '<div class="percent-inner"><span class="bar" style="width:' + arr[i].opt_text + '%"></span></div>' +
                                        '<span class="percent-val">' + arr[i].opt_text + '%</span>' +
                                    '</div>' +
                                '</li>';
            }
        }
    } else {//0 不显示投票结果
        if(type == '1') {//1是图片选项投票
            for(var i = 0; i < arr.length; i++) {
                voteDataStr += '<li class="pic-item" data-id="' + arr[i].id + '"><i><img src="' + arr[i].image + '"></i><span class="vote-item-name">' + arr[i].item + '</span><em></em></li>';
            }
        } else {//0文字选项投票
            for(var i = 0; i < arr.length; i++) {
                voteDataStr += '<li data-id="' + arr[i].id + '"><span class="vote-item-name">' + arr[i].item + '</span><em></em></li>';
            }
        }
    }
    return voteDataStr;
}

//获取会员文章阅读权限
function trialStatus(json) {
    // show_status: 0未登录，1登录无试读次数，2登录有试读次数，3会员
    // content_num: 字数",
    // free_read_num: 试读次数

    var params = JSON.parse(json);
    if (params.show_status != 3) {
        $('.trial-mark, .trial-opt').show();
        $('.trial-btns').html(trialRenderBtns(params));
        $('.trial-msg .num').html(params.content_num);
    }
}

function trialRenderBtns(vals) {
    var html = '';
    if (vals.show_status == 0) {
        html = '<div class="trial-login"><button class="trial-login" style="width: 3.26rem;" onclick="jm.trialEvents(\'nologin\');">已是会员，请登录</button></div>';
    }
    if (vals.show_status == 2) {
        html = '<div class="trial-login"><button class="trial-login" onclick="jm.trialEvents(\'limitread\');">免费试读</button>\
            <div class="trial-opportunity">剩余<span class="num">'+ vals.free_read_num +'</span>次免费试读机会</div></div>';
    }
    var target = html + '<button class="trial-pay" style="width: 2rem;" onclick="jm.trialEvents(\'vip\');">开通会员</button>';
    return target;
}

var isMove = false;
if ($('.company-brand-buddles').length) {
    $('.article-tips p').last().css('padding-bottom', '0.18rem')
}
function webViewDidScroll(scrollY) {
    if (isMove) return;

    var distanceTop = parseInt($('.company-tips-top').offset().top);
    var distanceBottom = parseInt($('.company-tips-bottom').offset().top);

    if (scrollY < distanceTop) {
        updateCompanyCardStatus(1);
    } else if (scrollY >= distanceTop && scrollY < (distanceBottom + 22)) {
        updateCompanyCardStatus(0);
    } else {
        updateCompanyCardStatus(2);
        jm.hadCompanyShow();
        isMove = true;
    }
}

function updateCompanyCardStatus(status) {
    var buddles = $('.company-brand-buddles');
    if (status == 0) buddles.addClass('in');
    if (status == 1) buddles.removeClass('in');
    if (status == 2) {
        buddles.removeClass('in');
        $('.company-tips').append(buddles);
        setTimeout(function() {
            $('.company-tips').addClass('moved');
        });
    }
}

function initCompanyCardStatus(scrollY) {
    if (!$('.company-brand-buddles').length) {
        $('.company-tips').remove();
    } else {
        if (scrollY >= $('.company-tips').offset().top) {
            $('.content').append($('.company-brand-buddles'));
            isMove = true;
        }
    }
}

// 音频
<!--$(document).ready(function () {-->
var container = $('.content-container'),
    audioWrapper = $('.audio-wrapper'),
    timer = null;

init();
// 可能会有多个音频，逐个初始化音频控制事件
function init() {
    audioWrapper = $('.audio-wrapper');
    audioWrapper.find('.progress-bar-bg').unbind('mousedown').on('mousedown', function (e) {
        var self = $(this),
            wrapper = self.parents('.audio-wrapper'),
            index = wrapper.attr('index'),
            timeStamp = wrapper.attr('timeStamp');

        progressHandler(e, index, timeStamp);
    });

    audioWrapper.find('.progressDot').unbind('touchstart').on('touchstart', function (e) {
        var self = $(this),
            wrapper = self.parents('.audio-wrapper'),
            index = wrapper.attr('index'),
            timeStamp = wrapper.attr('timeStamp');

        dragDotHandler(e, index, timeStamp);
    });
}

// 播放音频
function playStatus(index, curStamp, timeStamp) {

var audioBox = audioWrapper.eq(index),
    audioPlay = audioBox.find('.audio-player');

clearInterval(timer);

// 播放当前音频之前，停止其它音频播放
audioWrapper.each(function(i){
    if(i != index) {
        audioEnded(i);
    }
});

// 改变播放/暂停图片
updateProgress(index, curStamp, timeStamp);
timer = setInterval(function() {

    if(Number(curStamp) < timeStamp) {
        curStamp++;
        updateProgress(index, curStamp, timeStamp);
    } else {
        audioEnded(index);
    }
}, 1000);
audioWrapper.find('.audio-player').removeClass('active').eq(index).addClass('active');
}

// 指定索引的音频暂停播放
function pauseStatus(index) {
    var audioBox = audioWrapper.eq(index);

    clearInterval(timer);
    audioBox.find('.audio-player').removeClass('active');
}


// 点击进度条跳到指定点播放
function progressHandler(e, index, timeStamp) {
    var audioBox = audioWrapper.eq(index);
    var pgsWidth = $('.progress-bar-bg').width();

    var rate = e.offsetX / pgsWidth;
    currentTime = timeStamp * rate;
    jm.musicUpdateProgress(index, currentTime);
    updateProgress(index, currentTime, timeStamp);
}

// 拖拽音频
function dragDotHandler (e, index, timeStamp) {
    var audioBox = audioWrapper.eq(index),
        audioBar = audioBox.find('.progress-bar-bg'),
        audioLeft = audioBar.offset().left - 5,
        audioW = audioBar.width(),
        maxLeft = audioLeft, // 向左最大可拖动距离
        maxRight =  audioW + audioLeft,
        currentTime = 0; // 向右最大可拖动距离

    e.preventDefault();
    e.stopPropagation();
    $(document).unbind("touchmove");
    $(document).unbind("touchend");

    // 开始拖动
    $(document).bind("touchmove", function(e){
        var clientX = e.originalEvent.changedTouches[0].clientX;
        var length = clientX - maxLeft;

        if ( clientX >= maxLeft && clientX <= maxRight) {
            if (length > maxRight) {
                length = maxRight;
            } else if (length < -maxLeft) {
                length = -maxLeft;
            }

            var rate = length / audioW;

            currentTime = timeStamp * rate;
            updateProgress(index, currentTime, timeStamp);
        }
    });

    // 拖动结束
    $(document).bind("touchend", function(e){
        $(document).unbind("touchmove");
        $(document).unbind("touchend");
        jm.musicUpdateProgress(index, currentTime);
    });
}

/**
 * 更新进度条与当前播放时间
 * @param {object} audio - audio对象
 */
function updateProgress(index, curStamp, timeStamp) {
    var audioBox = audioWrapper.eq(index),
        value = curStamp / timeStamp;

    audioBox.find('.progressDot').css('left', value * 100 + '%');
    audioBox.find('.progress-bar').css('width', value * 100 + '%');
    audioBox.find('.audio-length-current').html(transTime(curStamp));
}

/**
 * 播放完成时把进度调回开始的位置
 */
function audioEnded(index) {
    var audioBox = audioWrapper.eq(index);

    clearInterval(timer);
    audioBox.find('.progressDot').css('left', 0);
    audioBox.find('.progress-bar').css('width', 0);
    audioBox.find('.audio-length-current').html('00:00');
    audioBox.find('.audio-player').removeClass('active');
}

/**
 * 音频播放时间换算
 * @param {number} value - 音频当前播放时间，单位秒
 */
function transTime(value) {
    var time = "";
    var h = parseInt(value / 3600);
    value %= 3600;
    var m = parseInt(value / 60);
    var s = parseInt(value % 60);
    if (h > 0) {
        time = formatTime(h + ":" + m + ":" + s);
    } else {
        time = formatTime(m + ":" + s);
    }

    return time;
}

/**
 * 格式化时间显示，补零对齐
 * eg：2:4  -->  02:04
 * @param {string} value - 形如 h:m:s 的字符串
 */
function formatTime(value) {
    var time = "";
    var s = value.split(':');
    var i = 0;
    for (; i < s.length - 1; i++) {
        time += s[i].length == 1 ? ("0" + s[i]) : s[i];
        time += ":";
    }
    time += s[i].length == 1 ? ("0" + s[i]) : s[i];
    return time;
}

/*
关联个人公司*/
function renderRelateTags(arr) {
    document.getElementById('top_relative_id').innerHTML = '<ul class="relate-tag-list"></ul>';
    var str = '',
        arrs = JSON.parse(arr);

    arrs.forEach(function(item) {
        str += '<div class="relate-tag '+ (item.object_type ? item.object_type : '') +'" data-type="'+ item.object_type +'" data-id="'+ item.id +'" data-name="'+ item.name +'">\
                    <span class="relate-tag-name">'+ item.name +'</span>\
               </div>'
    });

    if ($('.relate-tag-list').length) {
        $('.relate-tag-list')[0].innerHTML = str;
        bindRelateTagsEvent();
    }
}

function bindRelateTagsEvent() {
    $('.relate-tag-list .relate-tag').on('click', function() {
        var type = $(this).attr('data-type');
        var id = $(this).attr('data-id');
        window.jm.companyDetail(type,id)
    });
}
